#include "ode_solver.h"

void Euler(particle &p, double a, double dt)
{
	const double v_old = p.v;
	p.v += a*dt;
	p.x += v_old*dt;
	p.t += dt;
}

void EulerCromer(particle &p, double a, double dt)
{
	p.v += a*dt;
	p.x += p.v*dt;
	p.t += dt;
}

void Verlet(particle &p, double (&accel)(const particle&), double dt)
{
	const double a1 = accel(p);
	p.x += p.v*dt + 0.5*a1*dt*dt;
	const double a2 = accel(p);
	p.v += 0.5*(a1+a2)*dt;
	p.t += dt;
}
